<?php
// From App
// https://github.com/chipik/ya_perezvonu/blob/21551f88716bb27d4dc269bd1fc9aafa24506620/rev/README.md
$token = 'hphofd5757307f5dbffce25ae9ef4bd54dc56e770bc763215e7dc4f02e3';
$aes_key = '764fe50cdb21a07c4c049377754c2f50f127febb3aa67e03c7334f414e0fa7db';
$hmac_key = '2Wq7)qkX~cp7)H|n_tc&o+:G_USN3/-uIi~>M+c ;Oq]E{t9)RC_5|lhAA_Qq%_4';

$request_uri = 'https://pbssrv-centralevents.com/v2.5/search';
$request_body_plain = '{"countryCode":"RU","source":"search","token":"%s","phoneNumber":"%s"}';
$request_body_enc = '{"data":"%s"}'; 

// Request/Response crypto
function decrypt($key, $garble)
{
    return openssl_decrypt
    (
        base64_decode($garble),
        "aes-256-ecb",
        $key,
        OPENSSL_RAW_DATA
    );
}

function encrypt($key, $garble)
{
    $ivSize = openssl_cipher_iv_length('AES-256-ECB');
    $iv = openssl_random_pseudo_bytes(16);

    return openssl_encrypt
    (
        $garble,
        "aes-256-ecb",
        $key,
        OPENSSL_RAW_DATA
    );
}

function get_number_info($phone)
{
    global $aes_key, $token, $hmac_key, $request_body_plain, $request_body_enc, $request_uri;

    $time = time();
    $request_plain = sprintf($request_body_plain, $token, $phone);
    $hmac_data = $time . '-' . $request_plain;
    $signature = base64_encode(hash_hmac('sha256', $hmac_data, $hmac_key, true ));
    $request_encrypted = base64_encode(encrypt(hex2bin($aes_key), $request_plain));

    $curl = curl_init();
    curl_setopt_array
    (
        $curl,
        array
        (
            CURLOPT_URL => $request_uri,
            CURLOPT_POST => 1,
            CURLOPT_POSTFIELDS => sprintf($request_body_enc, $request_encrypted),

            CURLOPT_SSL_VERIFYHOST => 2,
            CURLOPT_SSL_VERIFYPEER => 1,
            
            CURLOPT_USERAGENT => 'Dalvik/2.1.0 (Linux; U; Android 6.0.1; Blackphone 2 Build/MOB31Z)',
            CURLOPT_HTTPHEADER => array
            (
                'X-App-Version: 4.9.1',
                'X-Token: ' . $token,
                'X-Os: android 6.0.1',
                'X-Client-Device-Id: 14130e29cebe9c39',
                'Content-Type: application/json; charset=utf-8',
                'Accept-Encoding: deflate',
                'X-Req-Timestamp: ' . $time,
                'X-Req-Signature: ' . $signature,
                'X-Encrypted: 1'
            ),
            CURLOPT_RETURNTRANSFER => 1
        )
    );

    $response = curl_exec($curl);
    curl_close($curl);

    $response = json_decode($response);
    $response = decrypt(hex2bin($aes_key), $response->data);

    return $response;
}


if (
    isset($_POST['phone'])
    &&
    !empty($_POST['phone'])
    &&
    !is_array($_POST['phone'])
)
{
    header("Content-type: application/json; charset=utf-8");
    echo get_number_info($_POST['phone']);
    exit;
}
?>
<html>
<head>
    <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/materialize/0.100.2/css/materialize.min.css">
    <script src="https://code.jquery.com/jquery-3.3.1.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/materialize/0.100.2/js/materialize.min.js"></script>
</head>
<body>
<form class="req-form" action="#">
    <div class="row">
        <div class="input-field col">
            <i class="material-icons prefix">phone</i>
            <input id="icon_telephone" type="tel" class="validate" name="phone" autocomplete="off" required>
            <label for="icon_telephone">Telephone</label>
        </div>
        <div class="input-field col s12">
            <button class="btn waves-effect waves-light" type="button" name="submit">Submit
                <i class="material-icons right">send</i>
            </button>
            <button class="btn waves-effect waves-light" type="button" name="clear">Clear
                <i class="material-icons right">clear</i>
            </button>
        </div>
    </div>
</form>
<ul class="collection">
</ul>
<script>
    var substitutor = (function () {
        var regEx = /{([^{]*?)}/g;

        var checkForSubstitutors = function (str) {
            return regEx.test(str);
        }

        var getSubstitueValue = function (context) {
            return function (regexMatch, placeholder) {
                var splitArray = placeholder.split(".")
                var currentContext = context;
                while (splitArray.length) {
                    var item = splitArray.shift();
                    if (typeof(currentContext) === "object" && item in currentContext)
                        currentContext = currentContext[item];
                    else
                        return;
                }
                return currentContext;
            };
        };

        return function (input, context) {
            while (checkForSubstitutors(input)) {
                input = input.replace(regEx, getSubstitueValue(context));
            }
            return input
        };
    })();

    function display(data) {
        var rObj = $.parseJSON(JSON.stringify(data));
        if(!rObj) {
            $(".collection").append('<li class="collection-item active red">Erroneous server response</li>');
            return;
        }

        if (rObj.hasOwnProperty('result')) {
            $(".collection").append('<li class="collection-item active green">Searches left: ' + rObj.result.subscriptionInfo.usage.search.remainingCount + '</li>');

            var html_main_tpl = `
<li class="collection-item avatar">
      <a href="{profileImage}"><img src="{profileImage}" target="_blank" class="circle"></a>
      <span class="title">{displayName}</span>
        <table class = "striped bordered s4">
         <tbody>
            <tr>
               <td>Имя</td>
               <td>{name}</td>
               <td>Фамилия</td>
               <td>{surname}</td>
            </tr>
            <tr>
               <td>Телефон</td>
               <td>{phoneNumber}</td>
               <td>E-mail</td>
               <td>{email}</td>
            </tr>
            <tr>
               <td>Пол</td>
               <td>{gender}</td>
            </tr>
            <tr>
               <td>Страна</td>
               <td>{country}</td>
               <td>Код страны</td>
               <td>{countryCode}</td>
            </tr>
            <tr>
                <td>Всего имен (tagCount?)</td>
                <td>{tagCount}</td>
            </tr>
`;
            var html_entry_tpl = `
            <tr>
                <td>Имя</td>
                <td>{name}</td>
                <td>Кол-во упоминаний</td>
                <td>{count}</td>
            </tr>
`;
            var html_tail_tpl = `
         </tbody>
      </table>
    </li>
`;

            var html = substitutor(html_main_tpl, rObj.result.profile);
            if(rObj.result.profile.tagCount > 0) {
                $.each(rObj.result.profile.tags, function (j, item_entry) {
                    var entry = substitutor(html_entry_tpl, item_entry);
                    html += entry;
                    }
                );
            }

            $(".collection").append(html + html_tail_tpl);
        }
        else {
            $(".collection").append('<li class="collection-item active red">Error ' + rObj + '</li>');
        }
    }

    function send_query() {
        $.post(
            {
                type: "POST",
                url: window.location,
                data: $('form').serializeArray(),
                success: function (data) {
                    display(data);
                }
            });
    }

    $('.input-field').find("input[name=phone]").keypress(function (e) {
        if (e.which == 13) {
            send_query();
            return false;
        }
    });

    $(".input-field").find("button[name=submit]").click(function () {
        send_query();
    });

    $(".input-field").find("button[name=clear]").click(function () {
        $(".collection").empty();
    });
</script>
</body>
</html>
